#!/usr/bin/env python3

from .PID import PID
import time
import os

class Controller:
    def __init__(self):

        self.pid = PID(100, 1, 0.1)
        self.pid.SetPoint = 60
        self.pid.setSampleTime(0.5)
        self.acpi_hwmon = ""
        self.gpu_hwmon = ""
        self.speed = 0

        for subdir, dirs, files, in os.walk("/sys/class/hwmon"):
            for dir in dirs:
                name = open("/sys/class/hwmon/" + dir + "/name").read().strip()
                if name == "jupiter":
                    self.acpi_hwmon = "/sys/class/hwmon/" + dir
                if name == "amdgpu":
                    self.gpu_hwmon = "/sys/class/hwmon/" + dir

        # Attempt to disable firmware management
        ramp_rate_file = open(self.acpi_hwmon + "/ramp_rate", "w")
        ramp_rate_file.write(str(0))
        gain_file = open(self.acpi_hwmon + "/gain", "w")
        gain_file.write(str(0))

        speed_file = open(self.acpi_hwmon + "/speed", "w")
        while True:
            with open(self.gpu_hwmon + "/temp1_input", 'r') as f:
                temp = int(f.read().strip()) / 1000

            self.pid.update(temp)
            pid_output = self.pid.output * -1
            self.speed = self.speed + pid_output
            self.speed = max(min(65534, self.speed), 0)
            speed_file.write(str(int(self.speed)))
            time.sleep(0.5)

def main():
    Controller()

if __name__ == '__main__':
    main()
